<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFrequentlyUsedDeviceItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfFrequentlyUsedDeviceItem extends AbstractStructArrayBase
{
    /**
     * The ZoneAndActivations
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\FrequentlyUsedDeviceItem[]
     */
    public $ZoneAndActivations;
    /**
     * Constructor method for ArrayOfFrequentlyUsedDeviceItem
     * @uses ArrayOfFrequentlyUsedDeviceItem::setZoneAndActivations()
     * @param \CustomerManagement\StructType\FrequentlyUsedDeviceItem[] $zoneAndActivations
     */
    public function __construct(array $zoneAndActivations = array())
    {
        $this
            ->setZoneAndActivations($zoneAndActivations);
    }
    /**
     * Get ZoneAndActivations value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\FrequentlyUsedDeviceItem[]|null
     */
    public function getZoneAndActivations()
    {
        return isset($this->ZoneAndActivations) ? $this->ZoneAndActivations : null;
    }
    /**
     * This method is responsible for validating the values passed to the setZoneAndActivations method
     * This method is willingly generated in order to preserve the one-line inline validation within the setZoneAndActivations method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateZoneAndActivationsForArrayConstraintsFromSetZoneAndActivations(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFrequentlyUsedDeviceItemZoneAndActivationsItem) {
            // validation for constraint: itemType
            if (!$arrayOfFrequentlyUsedDeviceItemZoneAndActivationsItem instanceof \CustomerManagement\StructType\FrequentlyUsedDeviceItem) {
                $invalidValues[] = is_object($arrayOfFrequentlyUsedDeviceItemZoneAndActivationsItem) ? get_class($arrayOfFrequentlyUsedDeviceItemZoneAndActivationsItem) : sprintf('%s(%s)', gettype($arrayOfFrequentlyUsedDeviceItemZoneAndActivationsItem), var_export($arrayOfFrequentlyUsedDeviceItemZoneAndActivationsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ZoneAndActivations property can only contain items of type \CustomerManagement\StructType\FrequentlyUsedDeviceItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ZoneAndActivations value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\FrequentlyUsedDeviceItem[] $zoneAndActivations
     * @return \CustomerManagement\ArrayType\ArrayOfFrequentlyUsedDeviceItem
     */
    public function setZoneAndActivations(array $zoneAndActivations = array())
    {
        // validation for constraint: array
        if ('' !== ($zoneAndActivationsArrayErrorMessage = self::validateZoneAndActivationsForArrayConstraintsFromSetZoneAndActivations($zoneAndActivations))) {
            throw new \InvalidArgumentException($zoneAndActivationsArrayErrorMessage, __LINE__);
        }
        if (is_null($zoneAndActivations) || (is_array($zoneAndActivations) && empty($zoneAndActivations))) {
            unset($this->ZoneAndActivations);
        } else {
            $this->ZoneAndActivations = $zoneAndActivations;
        }
        return $this;
    }
    /**
     * Add item to ZoneAndActivations value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\FrequentlyUsedDeviceItem $item
     * @return \CustomerManagement\ArrayType\ArrayOfFrequentlyUsedDeviceItem
     */
    public function addToZoneAndActivations(\CustomerManagement\StructType\FrequentlyUsedDeviceItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\FrequentlyUsedDeviceItem) {
            throw new \InvalidArgumentException(sprintf('The ZoneAndActivations property can only contain items of type \CustomerManagement\StructType\FrequentlyUsedDeviceItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ZoneAndActivations[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\FrequentlyUsedDeviceItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\FrequentlyUsedDeviceItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\FrequentlyUsedDeviceItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\FrequentlyUsedDeviceItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\FrequentlyUsedDeviceItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ZoneAndActivations
     */
    public function getAttributeName()
    {
        return 'ZoneAndActivations';
    }
}
